/*******************************************************************************
* FILE NAME: CmrWndow.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class:                                                  *
*     CameraWindow                                                             *
* ---------------------------------------------------------------------------- *
* Warning: This file was generated by the VisualAge C++ Visual Builder.        *
* Modifications to this source file will be lost when the part is regenerated. *
*******************************************************************************/
#ifndef _CAMERAWINDOW_
#define _CAMERAWINDOW_  

class CameraWindow;

#ifndef _IFRAME_
#include <iframe.hpp>
#endif

class IMultiCellCanvas;
class IStaticText;
class IEntryField;
class ISetCanvas;
class IPushButton;
#define INCL_WINSTDCNR
#include <os2.h>

#ifndef _CAMERA_
#include "Camera.hpp"
#endif

#ifndef _IVSEQ_H_
#include <ivseq.h>
#endif

#ifndef _IVBCNR_
#include <ivbcnr.h>
#endif

template <class Element> class IVSequence;
class Camera;
#ifndef _ISTDNTFY_
#include <istdntfy.hpp>
#endif

class DisplayWindow;
#ifndef _IVBVPRTP_
#include <ivbvprtp.h>
#endif

class CameraItemProvider;
#ifndef _IRECT_
#include <irect.hpp>
#endif

#ifndef _ISTRING_
#include <istring.hpp>
#endif

#include <idmhndlr.hpp>

class CameraWindowConn4;
class CameraWindowConn5;
class CameraWindowConn15;
class CameraWindowConn20;
class CameraWindowConn21;
class CameraWindowConn12;
class CameraWindowConn13;
#include "CmrWndow.h"


/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

//*****************************************************************************
// Class definition for CameraWindowVBContainerControl1CnrObj
//*****************************************************************************
class CameraWindowVBContainerControl1CnrObj : public IVBContainerObject {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   CameraWindowVBContainerControl1CnrObj(Camera& anObject);
   CameraWindowVBContainerControl1CnrObj(CameraWindowVBContainerControl1CnrObj& anObject);

   virtual  ~CameraWindowVBContainerControl1CnrObj();

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   IVBContainerObject & refreshFromObject();
   IVBContainerObject & updateToObject();
   CameraWindowVBContainerControl1CnrObj& operator=(const CameraWindowVBContainerControl1CnrObj& anObject);
   Camera* realObject() { return &pRealObject; }
;

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   Camera & pRealObject;


};   //CameraWindowVBContainerControl1CnrObj


//*****************************************************************************
// Class definition for CameraWindowCameraFactoryFactory
//*****************************************************************************
class CameraWindowCameraFactoryFactory : public IStandardNotifier {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   CameraWindowCameraFactoryFactory();

   virtual  ~CameraWindowCameraFactoryFactory();

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   Camera * create();
   CameraWindowCameraFactoryFactory & setEntryField1(IEntryField * aSelf) {iEntryField1 = aSelf; return *this;};
   CameraWindowCameraFactoryFactory & setEntryField2(IEntryField * aSelf) {iEntryField2 = aSelf; return *this;};
   CameraWindowCameraFactoryFactory & setEntryField3(IEntryField * aSelf) {iEntryField3 = aSelf; return *this;};

   //---------------------------------------------------------------------------
   // public member data
   //---------------------------------------------------------------------------
   static const INotificationId newObjectCreatedId;

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * iEntryField1;
   IEntryField * iEntryField2;
   IEntryField * iEntryField3;


};   //CameraWindowCameraFactoryFactory


//*****************************************************************************
// Class definition for CameraWindowDisplayWindowFactoryFactory
//*****************************************************************************
class CameraWindowDisplayWindowFactoryFactory : public IStandardNotifier {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   CameraWindowDisplayWindowFactoryFactory(unsigned long anId);

   virtual  ~CameraWindowDisplayWindowFactoryFactory();

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   DisplayWindow * create();

   //---------------------------------------------------------------------------
   // public member data
   //---------------------------------------------------------------------------
   static const INotificationId newObjectCreatedId;

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   unsigned long partWindowId;


};   //CameraWindowDisplayWindowFactoryFactory


//*****************************************************************************
// Class definition for CameraWindow
//*****************************************************************************
class CameraWindow : public IFrameWindow {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   CameraWindow(
      unsigned long id = WND_CameraWindow,
      IWindow* parent = IWindow::desktopWindow(),
      IWindow* owner = 0,
      const IRectangle& rect = defaultFramingSpec(),
      const IFrameWindow::Style& style = defaultStyle(),
      const char* title = defaultTitle());

   virtual  ~CameraWindow();

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   static const IRectangle defaultFramingSpec();
   static const IFrameWindow::Style defaultStyle();
   static IString defaultTitle();
   virtual CameraWindow & initializePart();
   CameraWindow * getFrameWindow() { return this; };

   //---------------------------------------------------------------------------
   // public member data
   //---------------------------------------------------------------------------
   static const INotificationId readyId;

protected:
   //---------------------------------------------------------------------------
   // protected member functions
   //---------------------------------------------------------------------------
   Boolean makeConnections();

private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IMultiCellCanvas * iMultiCellCanvas1;
   IStaticText * iStaticText1;
   IStaticText * iStaticText2;
   IStaticText * iStaticText3;
   IEntryField * iEntryField1;
   IEntryField * iEntryField2;
   IEntryField * iEntryField3;
   ISetCanvas * iSetCanvas1;
   IPushButton * iPushButton1;
   IVBContainerControl< Camera*, IVSequence<Camera*>, CameraWindowVBContainerControl1CnrObj > * iVBContainerControl1;
   IVSequence< Camera* > * iCameraList;
   CameraWindowCameraFactoryFactory * iCameraFactory;
   CameraWindowDisplayWindowFactoryFactory * iDisplayWindowFactory;
   IVBVariablePartPointer<DisplayWindow *> * inewDisplayWindow;
   CameraItemProvider * icameraItemProvider;
   CameraWindowConn4 * conn4;
   CameraWindowConn5 * conn5;
   CameraWindowConn15 * conn15;
   CameraWindowConn20 * conn20;
   CameraWindowConn21 * conn21;
   CameraWindowConn12 * conn12;
   CameraWindowConn13 * conn13;
   static unsigned long partWindowId;

friend class CameraWindowConn21;

};   //CameraWindow


/*----------------------------------------------------------------------------*/
/* Resume compiler default packing.                                           */
/*----------------------------------------------------------------------------*/
#pragma pack()

#endif
